#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "debug4xi.py">
#<abstract4xi abstract = "providing the function debug4xi"/>
#<refer4xi reference = "util.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'debug4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import atexit
    import logging         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>
 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from logger4xi import Logger4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


   
# -------------------------------------------------------------------------------------------------
#<function4xi function = "debub4xi" usage = "
#    reduction.py:
#        debug('starting listener and thread for sending handles')   
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def debug4xi(msg, *args):
    ''' 
    debug4xi function provides debugging messages
    '''
                
    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
      
    class2print = "debug4xi"
    method2print = "debug4xi"
                
    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
        
    message2print = "{passing" + "; msg-passing-to-print4xi-by-debug4xi: " + str(msg) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{informing" + "; replace-informing-by-debug4xi: " + " * replace debug4xi calls with print4xi calls !"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    message2print = "{returning" + "; debug4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi> 

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of debug4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

